
#include <fstream>
#include <cstring>
#include <cmath>
#include <vector>

using namespace std;

#include "Graph.h"

CGraph::CGraph()
{
    ntraces = 0;
    nwaves = 0;
    npts = 0;
//    xLabel = "";
//    yLabel = "";
    XAxisNo=0;
}

CGraph::~CGraph()
{
}


int CGraph::makeWaves(void)
{
    int i;
    if(ntraces <= 0) return -1;
    if(npts <= 0) return -1;
    
    W.resize(nwaves);
    for(i=0;i<nwaves;i++){
        W[i].A.resize(npts);
        W[i].visible = true;
    }
    
    XPStart = 0;
    XPEnd = npts-1;
    Points = npts;
    
    return 0;
}


void CGraph::findMinMax()
{
    int i,j;
    double* t;
    //		int imax, imin;
    double ymin,ymax;
    
    
    for(i=0;i<nwaves;i++){
        ymin=ymax=W[i].A[0];
        //			imax = imin = 0;
        t = &(W[i].A[0]);
        for(j=1;j<npts;j++){
            if(t[j] > ymax){
                ymax= t[j];
                //					imax = j;
            }else if ( t[j] < ymin){
                ymin = t[j];
                //					imin = j;
            }
        }
        
        W[i].aMax=ymax;
        W[i].aMin=ymin;
        //            
        //             if(imin<=imax){
        //             W[i]->iStart = imin;
        //             W[i]->iEnd   = imax;
        //             }else{
        //             W[i]->iStart = imax;
        //             W[i]->iEnd   = imin;
        //             }
        //             
        if(i==1){
            TheYMax = ymax;
            TheYMin = ymin;
        }else{
            if(TheYMax<ymax) TheYMax = ymax;
            if(TheYMin>ymin) TheYMin = ymin;
        }
    }
    YMax = TheYMax;
    YMin = TheYMin;
    return;
}

void CGraph::findXRange(double lower, double upper)
{
    double* pA = &(W[XAxisNo].A[0]);
    
    int ixmin, ixmax;
    bool bFound = false;
    
    for(int i = XPStart ; i<=XPEnd ; i++){
        double f = pA[i];
        if((f>=lower) && (f<=upper)){
            if(!bFound){
                ixmax = ixmin = i;
                bFound = true;
            }else{
                ixmax = i;
            }
        }
    }
    
    if(!bFound) return;
    
    if(ixmin==ixmax){
        if(ixmin>0)ixmin--;
        if(ixmax<npts-1)ixmax++;
    }
    XPStart = ixmin;
    XPEnd = ixmax;
    Points = XPEnd - XPStart + 1;
    
}




void CGraph::fullGraph()
{
    XPStart = 0;
    XPEnd = npts-1;
    
    XMin = W[XAxisNo].aMin;
    XMax = W[XAxisNo].aMax;
    
    findXRange(XMin, XMax);
    
    
    XOrigin = XMin;
    XDelta  = (Points>0) ? (XMax - XMin)/Points : 0;
    
    YMax = TheYMax;
    YMin = TheYMin;
}




int CGraph::CountTraceNumberB(char* filename)
{
    int i,m,len;
    int nt;
    double a0, a1, d0,d1;
    bool Success=false;
    
    fstream	fs(filename, ios::in | ios::binary);
    if(fs.fail()) return 0;
    fs.seekg(0, ios::end);
    
    len = fs.tellg()/sizeof(double);
    fs.seekg(0,ios::beg);
    
    for(m=2 ; m < len/2 ; m++){
        if(len % m ==0){
            //				br->BaseStream->Position=0;
            //				a0 = br->ReadDouble();
            fs.seekg(0,ios::beg);
            fs.read((char*)&a0, sizeof(double));
            //				br->BaseStream->Position=m*sizeof(double);
            //				d0 = br->ReadDouble() -a0;
            fs.seekg(m*sizeof(double),ios::beg);
            fs.read((char*)&a1, sizeof(double));
            d0 = a1 - a0;
            
            if(d0!=0){
                i=2;
                while(1){
                    //						br->BaseStream->Position=i*m*sizeof(double);
                    //						d1 = (br->ReadDouble()-a0)/(double)i;
                    
                    
                    fs.seekg(i*m*sizeof(double),ios::beg);
                    fs.read((char*)&a1, sizeof(double));
                    d1 = (a1-a0)/(double)i;
                    
                    if(fabs((d1-d0)/d0)>1e-3 ){
                        break;
                    }
                    i++;
                    if((i*m>=len) || (i>30)){
                        Success=true;
                        break;
                    }
                }
            }
        }
        if(Success)break;
    }
    fs.close();
    
    nt = m-1;
    
    if(!Success){
        return 0;
        /*			inputdialog^ idb = gcnew inputdialog("Input No. of traces:");
         idb->ShowDialog();
         if(idb->ResultOK){
         nt = idb->n;
         }else{
         return 0;
         }
         */
    }
    return nt;
    
}

/*
 int CGraph::CountTraceNumberT(string filename)
 {
 StreamReader^ sr = gcnew StreamReader(filename);
 String^ s;
 
 s = sr->ReadLine();
 sr->Close();
 
 int i;
 int count = 0;
 bool bWhite=true;
 for(i=0;i<s->Length;i++){
 if(Char::IsWhiteSpace(s,i)){
 if(!bWhite){ // changed from non-white -> white
 bWhite=true;
 }
 }else{ // not while
 
 if(bWhite){ // changed from white -> non-white
 bWhite=false;
 count++;
 }
 }
 }
 count = count -1;
 if(count<0)count=0;
 return count;
 }
 */
int CGraph::ReadBinaryDataFile(char* strFileName, int nt)
{
    int i,j;
    //		interior_ptr<double> p;
    //		array<Byte>^ buf;
    //		FileStream^ fs;
    //        BinaryReader^ br;
    
    //		fs = gcnew FileStream(strFileName, FileMode::Open, FileAccess::Read);
    //		br = gcnew BinaryReader(fs);
    
    fstream fs(strFileName, ios::in | ios:: binary);
    if(fs.fail())return 0;
    fs.seekg(0,ios::end);
    
    
    npts = fs.tellg()/((nt+1)*sizeof(double));
    
    ntraces = nt;
    nwaves = nt+1;
    
    //		br->BaseStream->Position=0;
    fs.seekg(0,ios::beg);
    
    makeWaves();
    
//    double* buf = new double[nwaves];
  
    vector<double> buf(nwaves,0.0);
    for(i=0;i<npts;i++){
        fs.read((char*)&buf[0], nwaves * sizeof(double));
        for(j=0;j<nwaves;j++){
            W[j].A[i] = buf[j];
        }
    }
    
    //		br->Close();
    fs.close();
    
    
//    delete [] buf;
    return npts;
}


int CGraph::OpenFile(char* sFileName, int nTraces)
{
    int nt =0;
	int npts=0;
    
    if(sFileName==""){
        /*
         OpenFileDialog^ openFileDialog1 = gcnew OpenFileDialog;
         openFileDialog1->Filter = "dat files (*.dat)|*.dat|All files (*.*)|*.*";
         openFileDialog1->FilterIndex = 2;
         openFileDialog1->RestoreDirectory = true;
         
         if ( openFileDialog1->ShowDialog() != System::Windows::Forms::DialogResult::OK ){
         return 0;
         }
         
         sFileName = openFileDialog1->FileName;
         */
        return 0;
    }
    
    if(strstr(sFileName,".dat")!=NULL){
        if(nTraces==0){
            nt = CountTraceNumberB(sFileName);
            if(nt==0) return 0;
        }else{
            nt=nTraces;
        }
        npts = ReadBinaryDataFile(sFileName, nt);
    }
    /*        
     else if(sFileName->Contains(".txt")){
     if(nTraces==0){
     nt = CountTraceNumberT(sFileName);
     }else{
     nt = nTraces;
     }
     npts = ReadTextDataFile(sFileName, nt);
     }
     */
    if(npts<=0)return 0;
    
    XAxisNo = 0;
    findMinMax();
    
    XOrigin = W[0].aMin;
    XDelta  = (W[0].aMax - W[0].aMin)/(npts-1);
    
    XPStart = 0;
    XMin = W[0].aMin;
    XMax = W[0].aMax;
    
    return npts;
}

